Attribute VB_Name = "DECLARES"

'Constants and Declare statements for API calls to Cypress Enable
Public Const ENS_RUNTIMEERROR = &H8007065B     ' Runtime error
Public Const ENS_HIT_BREAKPOINT = &H40202       ' Encountered breakpoint

' The string pointer returned from enaVersion is not a BSTR, so we can't use it
Declare Sub enaVersion Lib "enable40.dll" (ByRef major As Long, ByRef minor As Long)
Declare Function enaCreateContext Lib "enable40.dll" Alias "enaCreateContextA" _
    (ByVal contextName As String, ByVal hInst As Long, ByVal hWnd As Long, pEnaCtx As Long) As Long
Declare Function enaSetOption Lib "enable40.dll" (ByVal context As Long, ByVal lOption As Long, ByVal lParam As Long) As Long
Declare Function enaAddTypeLibFileRef Lib "enable40.dll" Alias "enaAddTypeLibFileRefA" _
    (ByVal context As Long, ByVal szFile As String, ByVal dwFlags As Long) As Long

Declare Function enaRegisterGetProcAddrCallback Lib "enable40.dll" Alias "enaRegisterGetProcAddrCallbackW" _
    (ByVal context As Long, ByVal pFcn As Long) As Long
Declare Function enaRegisterOutputCallback Lib "enable40.dll" Alias "enaRegisterOutputCallbackW" _
    (ByVal context As Long, ByVal pFcn As Long) As Long
Declare Function enaAddFile Lib "enable40.dll" Alias "enaAddFileA" _
    (ByVal context As Long, ByVal Filename As String) As Long
Declare Function enaAppendText Lib "enable40.dll" Alias "enaAppendTextA" _
    (ByVal context As Long, ByVal sText As String) As Long
Declare Function enaAppendEditWindow Lib "enable40.dll" _
    (ByVal context As Long, ByVal hWnd As Long) As Long

Declare Function enaCompile Lib "enable40.dll" (ByVal context As Long) As Long

Declare Function enaSaveCompiledCode Lib "enable40.dll" Alias "enaSaveCompiledCodeA" _
    (ByVal context As Long, ByVal name As String) As Long
Declare Function enaLoadCompiledCode Lib "enable40.dll" Alias "enaLoadCompiledCodeA" _
    (ByVal context As Long, ByVal name As String) As Long

Declare Function enaDebugStep Lib "enable40.dll" (ByVal context As Long, bufNum As Long, lineNum As Long) As Long
Declare Function enaDebugStepInto Lib "enable40.dll" (ByVal context As Long, bufNum As Long, lineNum As Long) As Long

Declare Function enaSetGlobalIntegerVar Lib "enable40.dll" Alias "enaSetGlobalIntegerVarA" _
    (ByVal context As Long, ByVal varName As String, ByVal intVar As Integer) As Long
Declare Function enaSetGlobalLongVar Lib "enable40.dll" Alias "enaSetGlobalLongVarA" _
    (ByVal context As Long, ByVal varName As String, ByVal longVar As Long) As Long
Declare Function enaSetGlobalDoubleVar Lib "enable40.dll" Alias "enaSetGlobalDoubleVarA" _
    (ByVal context As Long, ByVal varName As String, ByVal dblVar As Double) As Long
Declare Function enaSetGlobalStringVar Lib "enable40.dll" Alias "enaSetGlobalStringVarA" _
    (ByVal context As Long, ByVal varName As String, ByVal strVar As String) As Long
Declare Function enaSetGlobalObjectVar Lib "enable40.dll" Alias "enaSetGlobalObjectVarA" _
    (ByVal context As Long, ByVal varName As String, ByVal objVar As Object) As Long
Declare Function enaSetGlobalVariantVar Lib "enable40.dll" Alias "enaSetGlobalVariantVarA" _
    (ByVal context As Long, ByVal varName As String, ByVal varVar As Variant) As Long
Declare Function enaSetGlobalVariantArrayVar Lib "enable40.dll" Alias "enaSetGlobalArrayVarA" _
    (ByVal context As Long, ByVal varName As String, ByRef arrVar() As Variant) As Long
Declare Function TestArray Lib "enable40.dll" Alias "enaSetGlobalArrayVarA" _
    (ByVal context As Long, ByVal varName As String, x() As Any) As Long

Declare Function enaSetGlobalArrayRef Lib "enable40.dll" Alias "enaSetGlobalArrayRefA" _
    (ByVal context As Long, ByVal varName As String, ByRef arrName() As Integer) As Long
Declare Function enaSetGlobalVariantArrayRef Lib "enable40.dll" Alias "enaSetGlobalArrayRefA" _
    (ByVal context As Long, ByVal varName As String, ByRef arrVar() As Variant) As Long
Declare Function enaSetGlobalVariantRef Lib "enable40.dll" Alias "enaSetGlobalVariantRefA" _
    (ByVal context As Long, ByVal varName As String, ByRef varVar As Object) As Long
Declare Function enaSetErrorCode Lib "enable40.dll" Alias "enaSetErrorCodeA" _
    (ByVal context As Long, ByVal scode As Long, ByVal runtimeErr As Integer, ByVal errStr As String) As Long

Declare Function enaExecute Lib "enable40.dll" (ByVal context As Long) As Long
Declare Function enaCallFunction Lib "enable40.dll" Alias "enaCallFunctionA" _
    (ByVal context As Long, ByVal funcName As String, ByVal args As Long, ByVal retVal As Long) As Long
Declare Function enaDebugGo Lib "enable40.dll" (ByVal context As Long, bufNum As Long, lineNum As Long) As Long

Declare Function enaGetGlobalIntegerVar Lib "enable40.dll" Alias "enaGetGlobalIntegerVarA" _
    (ByVal context As Long, ByVal funcName As String, intVar As Integer) As Long
Declare Function enaGetGlobalLongVar Lib "enable40.dll" Alias "enaGetGlobalLongVarA" _
    (ByVal context As Long, ByVal varName As String, longVar As Long) As Long
Declare Function enaGetGlobalDoubleVar Lib "enable40.dll" Alias "enaGetGlobalDoubleVarA" _
    (ByVal context As Long, ByVal varName As String, dblVarVar As Double) As Long
Declare Function enaGetGlobalStringVar Lib "enable40.dll" Alias "enaGetGlobalStringVarA" _
    (ByVal context As Long, ByVal varName As String, ByVal strVar As String, ByVal max As Integer) As Long

Declare Function enaFreeContext Lib "enable40.dll" (ByVal context As Long) As Long

Type OutputInfo
    context As Long                 ' Context in which error or print statment occurred
    outputType As Long              ' Type 0 indicates Print statement, 1 indicates
                                    ' general error, 2 compile error, 3 runtime error
    scode As Long                   ' Bit encoded HRESULT (see codes above)
    str As String                   ' Extra info (eg. function name), optional
    bufNum As Long                  ' Buffer number for syntax error
    lineNum As Long                 ' Line number for syntax error and for runtime error
    offset As Integer               ' Offset of token for syntax error
    tokenLen As Integer             ' Token length for syntax error
    runtimeErr As Long              ' Err.Number for runtime errors (see errors.txt)
    errMessage As String            ' Display error message (error type, line #, and text)
End Type

Type CustomEdit
    cbSize As Long                  ' Set equal to sizeof( ENCUSTOMEDIT )
    pszContextName As String        ' Parameter to enaCreateContext
    lUserParam As Long              ' Parameter to enaSetUserParam
    dwOptions As Long               ' Parameter to enaSetOption( ctx, dwOptions, TRUE )
    pfnGetProcAddr As Long          ' Parameter to enaRegisterGetProcAddrCallback
    pfnOutput As Long               ' Parameter to enaRegisterOutputCallback
    pfnUndefFunc As Long            ' Parameter to enaUndefFuncCallback
    pDefaultDispatch As Object      ' Parameter to enaSetDefaultDispatch
    pszDeclarations As String       ' Script fragment containing constant and functions declarations
    pfnSetGlobals As Long           ' This function gets called after enaCompile, but before any
                                    ' script code is executed to allow for calls to enaSetGlobal*
    pfnGetGlobals As Long           ' This function gets called before enaFreeContext to allow
                                    ' for retrieval of global variables (enaGetGlobal*)
    pfnAbout As Long                ' This function gets called for About menu processing
    szFileName As String * 260      ' Current open file name in EnableEdit control, Specify initial file
    pszReferences As String         ' Type library references
End Type ' customEdit

Const ENEDIT_DISPLAY_INIT_ERROR = &H1      ' Display a message on a script editor initialization error
Const ENEDIT_CALLING_FROM_VB = &H2         ' The caller of this function is a VB application or control

Declare Function enaScriptEditor Lib "enable40.dll" (pCustomEdit As Any, ByVal szCmdLine As String, ByVal iCmdShow As Long, ByVal flags As Long) As Long
Declare Function enaGetScriptDispatch Lib "enable40.dll" (ByVal ctx As Long, obj As Object) As Long

' Helper functions and templates

Function cvtToAddr(ByVal faddr As Long) As Long
  cvtToAddr = faddr
End Function

Function MyGetProcAddr(ByVal ctx As Long, ByVal funcName As String) As Long
  If funcName = "Factorial" Then
    MyGetProcAddr = cvtToAddr(AddressOf Factorial)
  Else
    MyGetProcAddr = 0
  End If
End Function

Function Output(outInfo As OutputInfo) As Long
  If outInfo.outputType = 0 Then    'This is a print statement
    MsgBox outInfo.errMessage, vbInformation
  Else                              'This is an error statement
    MsgBox outInfo.errMessage, vbExclamation
  End If
End Function

Function SetGlobals(ByVal ctx As Long) As Long
  ' Set the value global variables here
  SetGlobals = 0
End Function

Function GetGlobals(ByVal ctx As Long) As Long
  ' Get the value global variables here
  GetGlobals = 0
End Function

' Application defined functions

Public Function Factorial(ByVal ctx As Long, ByVal n As Integer) As Double
    On Error GoTo LError

    If n < 0 Then Err.Raise 5   ' Invalid procedure call or argument
    
    Dim d As Double
    d = 1
    
    Dim i As Integer
    For i = 1 To n
        d = d * i
    Next
    
    Factorial = d
    Exit Function

LError:
    ' Report the error
    enaSetErrorCode ctx, ENS_RUNTIMEERROR, Err.Number, ""
End Function

