// ScriptView.h : interface of the CScriptEditView class
//

class CScriptEditView : public CEditView
{
	DECLARE_DYNCREATE(CScriptEditView)

// Construction
public:
	CScriptEditView();

// Attributes
public:

// Operations
public:
	BOOL OpenFile(LPCTSTR lpszPathName);
	BOOL SaveFile(LPCTSTR lpszPathName);
	void SetDefaultDispatch( IDispatch *pDispatch ) { m_pDefDispatch = pDispatch; };

	HRESULT DisplayResultCodeMessage(HRESULT hr);
	HRESULT PrepareContext(HANDLE &hCtx);
	HRESULT CompileEditWindowScript();
	void FreeContext();

	HRESULT RunScript(LPCTSTR lpszScriptText);

// Overrides
public:
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CScriptEditView)
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	virtual BOOL Create(LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID, CCreateContext* pContext = NULL);
	//}}AFX_VIRTUAL

// Implementation
public:
	HANDLE	m_hCtx;
	IDispatch *m_pDefDispatch;

// Generated message map functions
protected:
	//{{AFX_MSG(CScriptEditView)
	afx_msg void OnUpdateRunStart(CCmdUI* pCmdUI);
	afx_msg void OnUpdateRunEnd(CCmdUI* pCmdUI);
	afx_msg void OnDebugStepInto();
	afx_msg void OnDebugStepOver();
	afx_msg void OnDebugToggleBreakpoint();
	afx_msg void OnDebugClearBreakpoints();
	afx_msg void OnRunStart();
	afx_msg void OnRunEnd();
	afx_msg void OnDestroy();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////
